// C Header File
// Created 8/24/2002; 9:34:17 PM

void
GraySprite16_OR_96x96 (short x, short y, short h,
		       unsigned short *sprite1,
		       unsigned short *sprite2, void *dest1, void *dest2)
{
  register long offset = (y * 12) + ((x >> 3) & 0xfffe);
  register long addr1 = (long) dest1 + offset;
  register long addr2 = (long) dest2 + offset;
  register unsigned short cnt = 16 - (x & 15);
  for (; h; h--, addr1 += 12, addr2 += 12)
    {
      *(long *) addr1 |= (long) ((*sprite1++) & 0xffff) << cnt;
      *(long *) addr2 |= (long) ((*sprite2++) & 0xffff) << cnt;
    }
}


void
Sprite16_AND_96x96 (short x, short y, short h, unsigned short *sprite,
		    void *dest)
{
  register long addr = (long) dest + (y * 12) + ((x >> 3) & 0xfffe);
  register unsigned short cnt = 16 - (x & 15);

  for (; h; h--, addr += 12)
    *(long *) addr &= ~((long) ~((*sprite++) & 0xffff) << cnt);
}

#define SetupHUD(idx)																									\
memcpy(HUDlight,bg_img_data[idx],576*2);															\
memcpy(HUDdark,(BYTE*)bg_img_data[idx]+(576*2),576*2);								\
memcpy(HUDmask,(BYTE*)bg_img_data[idx]+(576*2*2),576*2);							\
GraySprite16_OR_96x96(40,40,16,																				\
crosshairs[gamedata.cfg.crosshair],																		\
crosshairs[gamedata.cfg.crosshair]+16,																\
HUDlight,HUDdark);																										\
Sprite16_AND_96x96(40,40,16,																					\
crosshairs[gamedata.cfg.crosshair]+32,HUDmask);

void
SetBackground (short x, short y, void *addr)
{
  Sprite32_OR (x, y, 100,
	       (long *) bg_img_data[FIRST_OTHER_IDX_a3dgfx1], addr);
  Sprite32_OR (x + 32, y, 100,
	       (long *) bg_img_data[FIRST_OTHER_IDX_a3dgfx1] + 100, addr);
  Sprite32_OR (x + 64, y, 100,
	       (long *) bg_img_data[FIRST_OTHER_IDX_a3dgfx1], addr);
  Sprite32_OR (x + 96, y, 100,
	       (long *) bg_img_data[FIRST_OTHER_IDX_a3dgfx1] + 100, addr);
  Sprite32_OR (x + 128, y, 100,
	       (long *) bg_img_data[FIRST_OTHER_IDX_a3dgfx1], addr);

}



#define BlackGrayScreen()																					\
{																																	\
	memset(GetPlane(0),0xFF,3840);																	\
	memset(GetPlane(1),0xFF,3840);																	\
}

void
FreeMemory (void)
{
  short inc;
  if (allspr != NULL)
    {
      free (allspr);
      allspr = NULL;
    }

  if (ext_level_data != NULL)
    {
      free (ext_level_data);
      ext_level_data = NULL;
    }

  if (player != NULL)
    {
      free (player);
      player = NULL;
    }

  if (HUDlight != NULL)
    {
      free (HUDlight);
      HUDlight = NULL;
    }

  if (HUDdark != NULL)
    {
      free (HUDdark);
      HUDdark = NULL;
    }
  if (HUDmask != NULL)
    {
      free (HUDmask);
      HUDmask = NULL;
    }
  if (lscr != NULL)
    {
      free (lscr);
      lscr = NULL;
    }

  if (dscr != NULL)
    {
      free (dscr);
      dscr = NULL;
    }

  for (inc = 0; inc < GFX_FILE_COUNT; inc++)
    {
      if (gfxfile[inc])
	FAT_UnlockHandleOfFile (gfxfile[inc]);
    }
}

short
OpenGraphicsFiles (void)
{
  unsigned char *src = 0;
  short inc;
  short flag = 0;

  //-------------------------------------------------------------------------
  // try to load the used textures from a3dgfx1 ...
  //-------------------------------------------------------------------------
  if ((gfxfile[0] = FAT_GetHandleOfFile ("a3dgfx1")))
    {
      if ((src = FAT_LockHandleOfFile (gfxfile[0])))
	{
	  // load textures
	  if (!FAT_LoadTextures
	      (level_tex, src + 2, 0, TOTAL_TEXCONFIGS_IN_a3dgfx1))
	    {
	      src = 0;		// just to indicate something went wrong
	    }
	  for (inc = 0; inc < TOTAL_GENERICDATAS_IN_a3dgfx1; inc++)
	    {
	      if (!
		  (bg_img_data[inc] =
		   FAT_GetGenericData (src + 2, inc, FAT_DONTCHECKLENGTH)))
		{
		  src = 0;	// just to indicate something went wrong
		}
	    }
	}
    }
  if (!src)
    goto loadgfxfailure;
  //-------------------------------------------------------------------------
  // try to load the used textures from a3dgfx2 ...
  //-------------------------------------------------------------------------
  if ((gfxfile[1] = FAT_GetHandleOfFile ("a3dgfx2")))
    {
      if ((src = FAT_LockHandleOfFile (gfxfile[1])))
	{
	  // load textures
	  if (!FAT_LoadTextures
	      (sprite_tex, src + 2, 0, TOTAL_TEXCONFIGS_IN_a3dgfx2))
	    {
	      src = 0;		// just to indicate something went wrong
	    }
	}
    }
  if (!src)
    goto loadgfxfailure;
  //-------------------------------------------------------------------------
  // try to load the used textures from a3dgfx3...
  //-------------------------------------------------------------------------
  if ((gfxfile[2] = FAT_GetHandleOfFile ("a3dgfx3")))
    {
      if ((src = FAT_LockHandleOfFile (gfxfile[2])))
	{
	  // load textures
	  if (!FAT_LoadTextures
	      (model_tex, src + 2, 0, TOTAL_TEXCONFIGS_IN_a3dgfx3))
	    {
	      src = 0;		// just to indicate something went wrong
	    }
	  if (!
	      (arena_img_data =
	       FAT_GetGenericData (src + 2, GENIDX_gameopen,
				   FAT_DONTCHECKLENGTH)))
	    {
	      src = 0;		// just to indicate something went wrong
	    }
	  for (inc = FIRST_CROSSHAIR;
	       inc < FIRST_CROSSHAIR + TOTAL_CROSSHAIRS; inc++)
	    {
	      if (!
		  (crosshairs[inc - FIRST_CROSSHAIR] =
		   FAT_GetGenericData (src + 2, inc, FAT_DONTCHECKLENGTH)))
		{
		  src = 0;	// just to indicate something went wrong
		}
	    }

	}
    }
  if (!src)
    goto loadgfxfailure;


loadgfxfailure:
  //-------------------------------------------------------------------------
  // check if loading failed ...
  //-------------------------------------------------------------------------
  for (inc = 0; inc < GFX_FILE_COUNT; inc++)
    {
      if (!gfxfile[inc])
	flag = 1;
    }
  if (flag || !src)
    {
      FAT_UnloadEngine ();
      FreeMemory ();
      ArenaShowError (ARENA_GFX_FILE_ERROR);
      return 0;
    }
  return 1;

}

short
AllocateMemory (void)
{
  short a;
// Mem for sprite structures
  allspr = (FATSPRITE *) malloc ((MAX_SPRITES) * sizeof (FATSPRITE));
  player = (FATSPRITE *) malloc (sizeof (FATSPRITE));

//Mem for HUD
  HUDlight = malloc (576 * sizeof (short));
  HUDdark = malloc (576 * sizeof (short));
  HUDmask = malloc (576 * sizeof (short));

//Double buffer
  lscr = malloc (LCD_SIZE);
  dscr = malloc (LCD_SIZE);

  if ((allspr == NULL) || (HUDlight == NULL) || (HUDdark == NULL)
      || (HUDmask == NULL) || (player == NULL) || (lscr == NULL)
      || (dscr == NULL))
    {
      RestoreHandlerForINTs ();
      FAT_UnloadEngine ();
      FreeMemory ();
      ArenaShowError (ARENA_OUT_OF_MEM);
      return 0;
    }

  for (a = 0; a < (MAX_SPRITES); a++)
    {
      FAT_InitSprite (allspr + a);
      (allspr + a)->drawmode = SPRITEMODE_UNUSED;
    }

  return 1;
}





#define SetupFC(a)																									\
a = (FATCONFIG)																											\
	{																																	\
    0,					/* width of map								*/										\
    0,					/* height of map							*/										\
    NULL,				/* pointer to map data				*/										\
    level_tex,	/* pointer to textures array	*/										\
    0,					/* number of sprites					*/										\
    NULL,				/* the sprite array						*/										\
    96,					/* start pos_x								*/										\
    96,					/* start pos_y								*/										\
    ANGLE_EAST,	/* orientation								*/										\
    NULL,				/* destination plane0					*/										\
    NULL,				/* destination plane1					*/										\
    NULL,				/* background image						*/										\
    0						/* frame counter							*/										\
  }

void
InitGameStruct (void)
{
  short a;			//,b;
  gamedata.quitting = 0;
  gamedata.scorelimit = 0;
  gamedata.skill = 3;
  //gamedata.xsize = 0;
  //gamedata.ysize = 0;
  gamedata.gametype = 0;
  gamedata.teamflag = 0;
  gamedata.instagib = 0;
  gamedata.speed = 1;
  gamedata.negated = 0;		//For negative scores

  gamedata.cfg.fatlogo = 1;
  gamedata.cfg.arenalogo = 1;
  gamedata.cfg.fire = CALCULATOR ? (RowKey)
  {
  RR_F1}
  : (RowKey)
  {
  RR_2ND};
  gamedata.cfg.strafe = CALCULATOR ? (RowKey)
  {
  RR_F2}
  : (RowKey)
  {
  RR_DIAMOND};
  gamedata.cfg.hitfind = CALCULATOR ? (RowKey)
  {
  RR_F5}
  : (RowKey)
  {
  RR_SHIFT};
  gamedata.cfg.speedup = CALCULATOR ? (RowKey)
  {
  RR_F6}
  : (RowKey)
  {
  RR_ALPHA};
  gamedata.cfg.crosshair = 0;
  gamedata.cfg.radar = 1;
  strcpy (gamedata.cfg.name, "Human   \0");


  for (a = 0; a < MAX_ROCKETS; a++)
    {
      gamedata.rocket[a].inuse = 0;
      gamedata.rocket[a].player_idx = 0;
      gamedata.rocket[a].player_hit_idx = 0;
    }
  for (a = 0; a < MAX_PLAYERS + 1; a++)
    {
      gamedata.player[a].spr = NULL;
      gamedata.player[a].last_hit_dir = 0;
      gamedata.player[a].model = 0;
      gamedata.player[a].team = 0;
      gamedata.player[a].order = 0;
      gamedata.player[a].health = 100;
      gamedata.player[a].score = 0;
      gamedata.player[a].desire = 0;
      gamedata.player[a].data = 0;
      gamedata.player[a].move = 0;
      gamedata.player[a].dir = 1;
      gamedata.player[a].rx = 0;
      gamedata.player[a].ry = 0;
      gamedata.player[a].sangle = 0;
      gamedata.player[a].rocket_idx = 0;
      gamedata.player[a].rocket_multiplier = 1;
      gamedata.player[a].multiplier_count = MULTIPLIER_DIVISOR;
    }
  for (a = 0; a < 2; a++)
    {
      gamedata.flag[a].spr = NULL;
      gamedata.flag[a].inuse = SPRITE_FREE;
      gamedata.flag[a].player_idx = 0;
    }
  gamedata.sprites.rockets = 0;
  gamedata.sprites.players = 0;
  gamedata.sprites.ctfflags = 0;


  health = (COUNTER)
  {
    110, 30, 3, 0,
    {
    0}
    ,
    {
    0}
  };
  score = (COUNTER)
  {
    110, 42, 3, 0,
    {
    0}
    ,
    {
    0}
  };
}

void
SetupPlayerPointers (void)
{
  short a;

  gamedata.player[REAL_PLAYER_IDX].spr = player;

  for (a = 1; a < MAX_PLAYERS + 1; a++)
    {
      gamedata.player[a].spr = allspr + a - 1;
    }
}

void
SetupCTF (FATCONFIG * fc)
{
  short a;
  for (a = 0; a < 2; a++)
    {
      gamedata.flag[a].spr = allspr + gamedata.sprites.players + a;
    }
  gamedata.sprites.ctfflags = 2;
  SpawnCTFflagsFromMap (fc);
}

void
FixTeams (void)
{
  short a;
  for (a = gamedata.sprites.players; a >= 0; a--)
    {
      gamedata.player[a].team = 0;
    }
}

void
InputInfo (short x, short y, char *buffer, char *full, short maxlen)
{
//Thanks to the TIGCCLIB documentation!
  SCR_STATE ss;
  short key, i = 0;
  buffer[0] = 0;
  SaveScrState (&ss);
  do
    {
      sprintf (full, "%s_  ", buffer);
      DrawGrayStr (x, y, full, A_REPLACE);
      // Two spaces are required if F_4x6 font is used
      key = ngetchx ();

      if ((isalpha (key) && i < maxlen) || (isdigit (key) && i < maxlen))
	buffer[i++] = key;
      if (key == KEY_BACKSPACE && i)
	i--;
      buffer[i] = 0;
    }
  while (key != KEY_ENTER);
}

void
InputNum (short x, short y, char *buffer, char *full, short maxlen)
{
//Thanks to the TIGCCLIB documentation!
  SCR_STATE ss;
  short key, i = 0;
  buffer[0] = 0;
  SaveScrState (&ss);
  do
    {
      sprintf (full, "%s_  ", buffer);
      DrawGrayStr (x, y, full, A_REPLACE);
      // Two spaces are required if F_4x6 font is used
      key = ngetchx ();

      if ( /*(isalpha(key) && i < maxlen) || */ (isdigit (key) && i < maxlen))
	buffer[i++] = key;
      if (key == KEY_BACKSPACE && i)
	i--;
      buffer[i] = 0;
    }
  while (key != KEY_ENTER);
}
typedef struct
{
  short y;
  char *text;
}
SetupStruct;
void
SetupGame (void)
{
  char buffer[3];
  char buf[5];
  char limitstr[20];
#define SetupCount 6
  SetupStruct setup[SetupCount] = {
    {15 + display_offsety, (char *) "Number of Bots (0-5)?"},
    {40 + display_offsety, (char *) "Bot Skill?"},
    {48 + display_offsety, (char *) "0-Easy to 6-Insane"},
    {73 + display_offsety, (char *) "DM Teamplay? 1=Yes"},
    {15 + display_offsety, limitstr},
    {40 + display_offsety, (char *) "Instagib? 1=Yes"},
  };

FAT_AllKeysReleased();
  GrayOff ();
  RestoreHandlerForINTs ();
  ClrScr ();
  GrayOn ();

  SetBackground (display_offsetx, display_offsety, GetPlane (0));


  DrawGrayStrExt (0, setup[0].y, setup[0].text, A_NORMAL | A_CENTERED, F_6x8);
  InputNum (66 + display_offsetx, 24 + display_offsety, buffer, buf, 2);
  gamedata.sprites.players = atoi (buffer);
  if (gamedata.sprites.players > MAX_PLAYERS || gamedata.sprites.players < 0)
    gamedata.sprites.players = MAX_PLAYERS;
  if (gamedata.sprites.players)
    {
      DrawGrayStrExt (0, setup[1].y, setup[1].text, A_NORMAL | A_CENTERED,
		      F_6x8);
      DrawGrayStrExt (0, setup[2].y, setup[2].text, A_NORMAL | A_CENTERED,
		      F_6x8);
      InputNum (66 + display_offsetx, 59 + display_offsety, buffer, buf, 2);
      gamedata.skill = atoi (buffer);
      if (gamedata.skill < 0 || gamedata.skill > 7)
	gamedata.skill = 3;

      if (gamedata.gametype == 0)
	{
	  DrawGrayStrExt (0, setup[3].y, setup[3].text, A_NORMAL | A_CENTERED,
			  F_6x8);
	  InputNum (66 + display_offsetx, 82 + display_offsety, buffer, buf,
		    2);
	  gamedata.gametype = atoi (buffer);
	  if (gamedata.gametype >= MAX_GAMETYPES)
	    gamedata.gametype = 0;
	}

      switch (gamedata.gametype)
	{
	case DM:
	  strcpy (limitstr, "Frag Limit?");
	  break;
	case TEAM:
	  strcpy (limitstr, "Team Score Limit?");
	  break;
	case CTF:
	  strcpy (limitstr, "Capture Limit?");
	  break;
	}

      ClearGrayScreen ();
      SetBackground (display_offsetx, display_offsety, GetPlane (0));
      DrawGrayStrExt (0, setup[4].y, setup[4].text, A_NORMAL | A_CENTERED,
		      F_6x8);
      InputNum (66 + display_offsetx, 24 + display_offsety, buffer, buf, 2);
      gamedata.scorelimit = atoi (buffer);
    }
  DrawGrayStrExt (0, setup[5].y, setup[5].text, A_NORMAL | A_CENTERED, F_6x8);
  InputNum (66 + display_offsetx, 49 + display_offsety, buffer, buf, 2);
  gamedata.instagib = atoi (buffer);
  if (gamedata.instagib)
    gamedata.instagib = 1;

  GrayOff ();
  InstallDummyHandlerForINTs ();
  GrayOn ();
}


// Loads the config file
void
LoadConfig (void)
{
  short n;
//This structure holds the data to be loaded.
  ConfigStruct load_data;
  FILE *f;
  f = fopen ("a3dcfg", "rb");
// we must check to see if we opened the file successfully
  if (f != NULL)
    {
//Reads stuff
      n = fread (&load_data, sizeof (ConfigStruct), 1, f);
      fclose (f);
      gamedata.cfg = load_data;
    }
  else
    {
//Error, oh well
    }
}



void
SaveConfig (void)
{
  short n;
//Holds the data to save
  ConfigStruct save_data;
  FILE *f;

  save_data = gamedata.cfg;

  if ((SymFindPtr (SYMSTR ("a3dcfg"), 0)->flags.bits.archived) == 1)
    return;

  f = fopen ("a3dcfg", "wb");
// we must check to see if we opened the file successfully
  if (f != NULL)
    {
//Writes stuff
      n = fwrite (&save_data, sizeof (ConfigStruct), 1, f);
      fputc (0, f);
      fputs ("acfg", f);
      fputc (0, f);
      fputc (OTH_TAG, f);
      fclose (f);

    }
  else
    {
//Error, oh well
    }
}


void
PreHUDCallback (FATCONFIG * fc, unsigned short *plane0,
		unsigned short *plane1)
{
  short i;
  if (!gamedata.invert)
    return;
  fc = fc;			// to make the compiler happy ...
  for (i = 0; i < 6 * 96; i++, plane0++, plane1++)
    *plane0 = ~*plane0, *plane1 = ~*plane1;

  gamedata.invert--;
}



void
LoadExternalLevel (FATCONFIG * fc)
{
  short number = 0;
  short total_maps = 0;
  char buffer[HOWMANY * MAXLEN];
  char filestr[9] = { 0 };
  SYM_ENTRY *symptr = NULL;
  unsigned char *archive;
  short inc;

  if (noskip)
    {
      number = findAllFilesSet (buffer, "alev", HOWMANY);
      if (!number)
	{
	  gamedata.quitting = E2Q (ARENA_MAP_FILE_ERROR);
	  return;
	}
      number =
	domenu (35 + display_offsetx, 28 + display_offsety, buffer, number,
		0);
      if (number == -1)
	{
	  gamedata.quitting = E2Q (ARENA_MAP_FILE_ERROR);
	  return;
	}
      strcpy (filestr, buffer + number * MAXLEN);
    }
  else
    strncpy (filestr, setname, MAXLEN);

  symptr = DerefSym (SymFind (SYMSTR (filestr)));
  if (symptr)
    {
      archive = HLock (symptr->handle);
      archive += 2;

      total_maps = *(unsigned short *) archive;

//next comes a list of MAP_HEADERS
      MAP_HEADER *header = (MAP_HEADER *) (archive + 2);
//next comes the actual tilemaps
      unsigned char *map_data =
	(unsigned char *) (archive + 2 + sizeof (MAP_HEADER) * total_maps);

//adding the offset for the ith header to the start of the tilemaps will get a pointer
//to the start of the tilemap we want
      unsigned char *get_tile_map (unsigned short i)
      {
	return map_data + header[i].offset;
      }

      if (noskip)
	{
	  inc = 0;
	  FontSetSys (F_6x8);

	  FAT_AllKeysReleased ();

	  while (1)
	    {
	      char buf[20];
	      if (inc == -1)
		inc = total_maps - 1;
	      if (inc == total_maps)
		inc = 0;

	      ClearGrayScreen2B (lscr, dscr);
	      SetBackground (display_offsetx, display_offsety, lscr);
	      DrawGrayStr2B (1 + display_offsetx, 90 + display_offsety,
			     (char *) "<-", A_NORMAL, lscr, dscr);
	      DrawGrayStr2B (146 + display_offsetx, 90 + display_offsety,
			     (char *) "->", A_NORMAL, lscr, dscr);


	      DrawGrayStr2B (16 + display_offsetx, 28 + display_offsety,
			     (header + inc)->title, A_NORMAL, lscr, dscr);
	      DrawGrayStr2B (16 + display_offsetx, 38 + display_offsety,
			     (header + inc)->author, A_NORMAL, lscr, dscr);
	      DrawGrayStr2B (16 + display_offsetx, 48 + display_offsety,
			     (char *) ArenaGameTypes[(header + inc)->
						     gametype], A_NORMAL,
			     lscr, dscr);
	      sprintf (buf, "[%i,%i]", (header + inc)->xsize,
		       (header + inc)->ysize);
	      DrawGrayStr2B (40 + display_offsetx, 90 + display_offsety, buf,
			     A_NORMAL, lscr, dscr);
	      sprintf (buf, "INDEX #%i", inc);
	      DrawGrayStr2B (40 + display_offsetx, 80 + display_offsety, buf,
			     A_NORMAL, lscr, dscr);
	      FastCopyScreen (lscr, GetPlane (0));
	      FastCopyScreen (dscr, GetPlane (1));
	      if (Pressed (RR_LEFT))
		{
		  FAT_AllKeysReleased ();
		  inc--;
		}

	      else if (Pressed (RR_RIGHT))
		{
		  FAT_AllKeysReleased ();
		  inc++;
		}
	      else if (KeyIsPressed)
		break;



	    }
	}
      else
	{
	  inc = skipidx;
	  if (inc >= total_maps)
	    inc = 0;
	}
      fc->map_width = (header + inc)->xsize;
      fc->map_height = (header + inc)->ysize;
      gamedata.gametype = (header + inc)->gametype;
      if (!noskip && !gamedata.gametype)
	gamedata.gametype += gamedata.teamflag;
      if (ext_level_data != NULL)
	free (ext_level_data);
      ext_level_data =
	(char *) malloc (sizeof (char) * fc->map_width * fc->map_height);
      if (ext_level_data == NULL)
	{
	  gamedata.quitting = E2Q (ARENA_OUT_OF_MEM);
	  return;
	}


      memcpy (ext_level_data, get_tile_map (inc),
	      sizeof (char) * fc->map_width * fc->map_height);
      fc->map_data = ext_level_data;
      fc->background = bg_img_data[(header + inc)->background];

      return;
    }
}

void ShowEndOfMatch (void);


#define SWAP(a,b)   t=a; a=b; b=t;	// Macro for swapping

/***************************************************************
                      The Bubble Sort Itself
                      ----------------------
The bubble sort is probably one of the easiest sorting algorithms 
to understand. The function sifts through the array swapping 
pairs of numbers over and over again until it is finally sorted.

When it makes it's first pass, it compares the first two numbers
(or elements) of the array. If the first number is smaller than
the second number, it is swapped with that number. Then it 
compares the second and third numbers (or elements) of the array. 
If the second number is smaller than the third, it is swapped with
that number. It continues down the line until it has gone through
the entire array. Then it makes another pass through it doing
the same thing. It makes a pass for each element. So if an array
has 8 elements, the array will be sifted through 8 times. 
***************************************************************/
void
bubbleSortScores (short *a, short n)
{
  short i, j;
  short t;

  for (i = 0; i < n; i++)	// Make a pass through the array for each element
    {
      for (j = 1; j < (n - i); j++)	// Go through the array beginning to end
	{
	  if (a[(j - 1) * 2] < a[j * 2])	// If the the first number is smaller, swap it 
	    {
	      SWAP (a[(j - 1) * 2], a[j * 2]);
	      SWAP (a[(j - 1) * 2 + 1], a[j * 2 + 1]);
	    }

	}
    }
}

void
ShowFinalErrors (void)
{
  if (gamedata.quitting >= 0)
    {
      ST_helpMsg (END_STRING);
      return;
    }
  if (gamedata.quitting < -ARENA_ERROR_COUNT)
    return;
  ST_helpMsg (ArenaErrorStrings[E2Q (gamedata.quitting)]);
}

short
CheckForGameParameters (void)
{
/*----BEGIN code for parameter support-----
CALLING ARENA WITH PARAMETERS:
==============================
You can call Arena with parameters instead of using the GUI.
This can simplify running the game greatly if you normally
prefer the same setup. When you call Arena with correct
parameters, the logo, splash screen, main menu, and game
setup are all skipped. Pressing ESC in a game will quit the
game, not return to the main menu. If you call the game with
incorrect or missing parameters, you will get an error message
saying the correct usage to call the game in case you forget.
The game must be called with at least one parameter to show
that error.

Call:
arena(set_name,level_idx,teamplay_flag,instagib_flag,bot_count,bot_skill,game_fraglimit)
set_name = Level set name (must be a string enclosed in double quotes)
teamplay_flag = Only applies in Deathmatch mode. If this is set to 1, the
 game mode is teamplay, otherwise it's free-for-all. This doesn't apply to
 CTF. DM/ CTF base game mode is chosen from the map you pick.
instagib_flag = The game is Instagib (rockets hit instantly, i.e. no projectiles) when
this flag is set to 1.
level_idx = Level index in that set
bot_count = Number of bots
bot_skill = Bot skill/accuracy; 0-Easy to 6-Insane
game_fraglimit = Game frag/kill limit before end of match
*/
  ESI argptr;
  int argtype;

  noskip = 1;
  skipidx = 0;

  InitArgPtr (argptr);
  if ((argtype = GetArgType (argptr)) != END_TAG)
    {
      if (argtype == STR_TAG)
	{
	  strncpy (setname, GetStrnArg (argptr), 9);
	  if ((argtype = GetArgType (argptr)) == POSINT_TAG)
	    {
	      skipidx = (short) GetIntArg (argptr);
	      if ((argtype = GetArgType (argptr)) == POSINT_TAG)
		{
		  gamedata.teamflag = (short) GetIntArg (argptr);
		  if ((argtype = GetArgType (argptr)) == POSINT_TAG)
		    {
		      gamedata.instagib = (short) GetIntArg (argptr);
		      if (gamedata.instagib)
			gamedata.instagib = 1;
		      if ((argtype = GetArgType (argptr)) == POSINT_TAG)
			{
			  gamedata.sprites.players =
			    (short) GetIntArg (argptr);
			  if ((argtype = GetArgType (argptr)) == POSINT_TAG)
			    {
			      gamedata.skill = (short) GetIntArg (argptr);
			      if ((argtype =
				   GetArgType (argptr)) == POSINT_TAG)
				{
				  gamedata.scorelimit =
				    (short) GetIntArg (argptr);
				  noskip = 0;
				}
			    }
			}
		    }
		}
	    }
	}
      if (noskip)
	{
	  ST_helpMsg (ArenaParameterError);
	  FAT_UnloadEngine ();
	  FreeMemory ();
	  return 0;
	}
    }
  return 1;
/*---------END code for parameter support----------*/
}
